package com.xxrv.video.activity;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.text.TextUtils;
import android.util.Log;
import android.view.View;
import android.widget.FrameLayout;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.RelativeLayout;

import com.alibaba.android.arouter.facade.annotation.Route;
import com.chad.library.adapter.base.BaseQuickAdapter;
import com.frame.base.url.Constance;
import com.joe.camera2recorddemo.View.CameraRecordView;
import com.ruiwenliu.wrapper.base.BaseBean;
import com.ruiwenliu.wrapper.base.BaseStatusActivity;
import com.ruiwenliu.wrapper.weight.TitleView;
import com.xxrv.video.R;
import com.xxrv.video.R2;
import com.xxrv.video.dialog.FilterPreviewDialog;
import com.xxrv.video.presenter.VideoPresenter;
import com.xxrv.video.util.RecorderUtils;
import com.xxrv.video.weight.MarqueTextView;
import com.xxrv.video.weight.RecordButton;
import com.xxrv.video.weight.Xrecprogressbar;

import java.util.ArrayList;
import java.util.List;

import VideoHandle.EpEditor;
import VideoHandle.EpVideo;
import VideoHandle.OnEditorListener;
import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.OnClick;

/**
 * 发短视频
 */
@Route(path = Constance.ACTIVITY_URL_RECORDXACTIVITY)
public class RecordxActivity extends BaseStatusActivity<VideoPresenter> implements BaseQuickAdapter.RequestLoadMoreListener {

    @BindView(R2.id.surfaceView)
    CameraRecordView mRecordView;
    @BindView(R2.id.vCutoutHolder)
    View vCutoutHolder;
    @BindView(R2.id.xpbar)
    Xrecprogressbar xbar;
    @BindView(R2.id.tv_bgname)
    MarqueTextView tvBgname;
    @BindView(R2.id.ll_select_music)
    LinearLayout llMusic;
    @BindView(R2.id.ll_back)
    LinearLayout llBack;
    @BindView(R2.id.ll_swith)
    LinearLayout llSwith;
    @BindView(R2.id.ll_filter)
    LinearLayout llFilter;
    @BindView(R2.id.iv_comp)
    ImageView ivComp;
    @BindView(R2.id.iv_local)
    ImageView ivLocal;
    @BindView(R2.id.iv_del)
    ImageView ivDel;
    @BindView(R2.id.rl_more)
    RelativeLayout rlMore;
    @BindView(R2.id.btn_rec)
    RecordButton mRecordBtn;
    @BindView(R2.id.progress_ing)
    FrameLayout progressIng;


    private static final int STATE_INIT = 0;
    private static final int STATE_RECORDING = 1;
    private static final int STATE_PAUSE = 2;
    private static final int REQUEST_CODE_SELECT_VIDEO = 10;
    private List<EpVideo> videos;
    private FilterPreviewDialog mDialog;
    private int mRecorderState;


    BroadcastReceiver closeReceiver = new BroadcastReceiver() {
        @Override
        public void onReceive(Context context, Intent intent) {
            finish();
        }
    };


    FilterPreviewDialog.OnUpdateFilterListener listener = new FilterPreviewDialog.OnUpdateFilterListener() {
        @Override
        public void select(int type) {
            mRecordView.switchFilter(type);
        }

        @Override
        public void dismiss() {
            rlMore.setVisibility(View.VISIBLE);
            mRecordBtn.setVisibility(View.VISIBLE);
        }
    };


    @Override
    protected int setLayout() {
        return R.layout.activity_recordx;
    }

    @Override
    protected void initView(Bundle savedInstanceState, TitleView titleView, Intent intent) {
        showTitle(false);

        videos = new ArrayList<>();
        mDialog = new FilterPreviewDialog(this, listener);

        xbar.addOnComptListener(new Xrecprogressbar.OnCompteListener() {
            @Override
            public void onCompte() {
            stopRecord();
            mRecorderState = STATE_INIT;
            refreshControlUI();
            compteRecord();
            }
        });
    }

    @Override
    public void onLoadMoreRequested() {

    }

    @Override
    public void onShowResult(int requestType, BaseBean result) {

    }


    @OnClick({R2.id.ll_select_music, R2.id.ll_back, R2.id.ll_swith, R2.id.ll_filter, R2.id.iv_comp, R2.id.iv_local, R2.id.iv_del, R2.id.btn_rec, R2.id.progress_ing})
    public void onViewClicked(View view) {
        int id = view.getId();
        if (id == R.id.ll_select_music) {

        } else if (id == R.id.ll_back) {

        } else if (id == R.id.ll_swith) {

        } else if (id == R.id.ll_filter) {
            mDialog.show();
            rlMore.setVisibility(View.GONE);
            mRecordBtn.setVisibility(View.GONE);
        } else if (id == R.id.iv_comp) {

        } else if (id == R.id.iv_local) {

        } else if (id == R.id.iv_del) {

        } else if (id == R.id.btn_rec) {

        } else if (id == R.id.progress_ing) {

        }
    }



    /**
     * 结束录制
     *
     * @return
     */
    private boolean stopRecord() {
        try {
            mRecordView.stopRecord();
        } catch (InterruptedException e) {
            e.printStackTrace();
            return false;
        }
        return true;
    }


    private void exitRecord() {
        for (int i = videos.size() - 1; i > -1; i--) {
            EpVideo video = videos.get(i);
            RecorderUtils.delVideoFile(video.getVideoPath());
        }
        finish();
    }

    /**
     * 删除上一段视频
     */
    private void popDelVideo() {
        if (videos.size() > 0) {
            EpVideo video = videos.get(videos.size() - 1);
            RecorderUtils.delVideoFile(video.getVideoPath());
            videos.remove(videos.size() - 1);
        }

        if (videos.size() == 0) {
            llMusic.setVisibility(View.VISIBLE);
        }

        xbar.popTask();

        Log.e("xuan", "popDelVideo: " + videos.size());
    }

    /**
     * 完成录制
     */
    public void compteRecord() {
        VoiceManager.instance().stop();
        int length = videos == null ? 0 : videos.size();
        if (length == 0) {
            showToast(getString(R.string.record_frist_video));
        } else if (length == 1) { // 直接去拼合音乐
            showWaitDialog();
            EpVideo video = videos.get(0);
            appendBgm(video.getVideoPath());
        } else {
            VoiceManager.instance().stop();
            showWaitDialog();
            // 先去拼合视频
            Log.e("xuan", "即将要拼合: " + videos.size() + "个视频");
            final String outFile = RecorderUtils.getVideoFileByTime();
            EpEditor.mergeByLc(this, videos, new EpEditor.OutputOption(outFile), new OnEditorListener() {
                @Override
                public void onSuccess() {
                    appendBgm(outFile);
                }

                @Override
                public void onFailure() {
                    Log.e("xuan", "合并失败");
                    handler.sendEmptyMessage(RecorderUtils.MERGE_FAILURE);
                }

                @Override
                public void onProgress(float progress) {
                    //这里获取处理进度
                    Log.e("xuan", "正在合并" + progress);
                }
            });
        }
    }

    private void appendBgm(final String filePath) {
        if (TextUtils.isEmpty(mCurrBgmPath)) {
            mCurrPath = filePath;
            handler.sendEmptyMessage(RecorderUtils.MUSIC_SUCCESS);
            return;
        }

        final String outfilePath = RecorderUtils.getVideoFileByTime();
        mCurrPath = outfilePath;

        // 合并音效
        EpEditor.music(filePath, mCurrBgmPath, outfilePath, 0f, 1f, new OnEditorListener() {
            @Override
            public void onSuccess() {
                handler.sendEmptyMessage(RecorderUtils.MUSIC_SUCCESS);
            }

            @Override
            public void onFailure() {
                mCurrPath = filePath;
                handler.sendEmptyMessage(RecorderUtils.MUSIC_SUCCESS);
            }

            @Override
            public void onProgress(float progress) {
                //这里获取处理进度
                Log.e("xuan", "music正在合并" + progress);
            }
        });
    }


    private void refreshControlUI() {
        if (mRecorderState == STATE_RECORDING) {
            //1s后才能按停止录制按钮
            mRecordBtn.setEnabled(false);
            handler.sendEmptyMessageDelayed(RecorderUtils.ACTIVATE_BTN, 1000);
            mRecordBtn.record();
            rlMore.setVisibility(View.GONE);
            llMusic.setVisibility(View.INVISIBLE);
            xbar.record();
        } else if (mRecorderState == STATE_INIT) {
            mRecordBtn.pause();
            xbar.pause();
            rlMore.setVisibility(View.VISIBLE);
            if (videos.size() == 0) {
                ivDel.setVisibility(View.GONE);
                ivLocal.setVisibility(View.VISIBLE);
            } else {
                ivDel.setVisibility(View.VISIBLE);
                ivLocal.setVisibility(View.GONE);
            }
        }
    }

}
